dataProcessor.prototype._sendData = function(a1,rowId){
	if (!a1) return; //nothing to send
	if (!this.callEvent("onBeforeDataSending",rowId?[rowId,this.getState(rowId),a1]:[null, null, a1])) return false;				
	
	if (rowId)
		this._in_progress[rowId]=(new Date()).valueOf();

	var that = this;
	var back = function(xml){
		var ids = [];
		if (rowId)
			ids.push(rowId);
		else if (a1)
			for (var key in a1)
				ids.push(key);

		return that.afterUpdate(that,xml,ids);
	};
	
	var a3 = this.serverProcessor+(this._user?(dhtmlx.url(this.serverProcessor)+["dhx_user="+this._user,"dhx_version="+this.obj.getUserData(0,"version")].join("&")):"");

	if (this._tMode=="GET")
    	dhx4.ajax.get(a3+((a3.indexOf("?")!=-1)?"&":"?")+this.serialize(a1,rowId), back);
	else if (this._tMode == "POST")
    	dhx4.ajax.post(a3,this.serialize(a1,rowId), back);
    else if (this._tMode == "REST"){
    	var state = this.getState(rowId);
    	var url = a3.replace(/(\&|\?)editing\=true/,"");
    	var parts = url.split("?");
    	if (parts[1])
    		parts[1] = "?"+parts[1];

    	var data = "";
    	var method = "post";

    	if (state == "inserted"){
    		data = this.serialize(a1, rowId);
    	} else if (state == "deleted"){
    		method = "DELETE";
    		url = parts[0]+rowId+parts[1];
    	} else {
    		method = "PUT";
    		data = this.serialize(a1, rowId);
    		url = parts[0]+rowId+parts[1];
    	}

    	if (this._payload)
    		for (var key in this._payload)
    			url = url + (url.indexOf("?") === -1 ? "?" : "&" ) + this.escape(key) + "=" + this.escape(this._payload[key]);

    	dhx4.ajax.query({
    		url:url,
    		method:method,
    		headers:this._headers,
    		data:data,
    		callback:back
    	});
    }

	this._waitMode++;
}